//********************************************************
//
// Example Application of BRD_xxx functions for QM9857 service.
//
// (C) InSys by Sklyarov A. Oct, 2006
//
//=********************************************************

#include	<conio.h>
#include	<stdio.h>
#include	<tchar.h>
#include	<ctype.h>
#include	<windows.h>
#include	<dos.h>
//#include	<bios.h>

#include	"brd.h"
#include	"ctrlstrm.h"
#include	"CtrlQm9857.h"
#include	"CtrlCmpSC.h"
#define PI2   6.2831853071795864
#define		kSpace	0x3920

typedef struct 
{
 U32   WorkMode;
 U32   SamplesPerChannel;
 U32   IsSystemMemory;
 U32   MasterSlave;
 U32   ReadModeSDRAM;
 U32   IsAlwaysLoadPld;
 TCHAR IniFileName[256];
 TCHAR PldFileName[256];
 TCHAR ServiceName[256];
}EXAM_PARAM;

EXAM_PARAM g_ExamParam=
{
	1,		// WorkMode,
	1024,	// SamplesPerChannel
	0,		// IsSystemMemory
	0,		// MasterSlave;
	1,		// ReadModeSDRAM: 0-auto, 1 - free 
	0,		// IsAlwaysLoadPld: 1 - always
	{"\\exam_qm9857.ini"}, //IniFileName
	{""},		// PldFileName
	{"QM98570"}	// ServiceName
};
//---------------------------------------------------------------------------
typedef struct 
{
    U32  ClockSource;
    U32  ClockValue;
    U32  MaskChannels;
  	U32	 OperateMode;
  	U32	 CarrierFreq;
  	U32	 ModulateFreq;
	U32	 AmpModulateFreq;
	S32	 OffsetSampleModFreq;
  	U32	 OutputScaleFactor;
	U32	 RefClockMultiply;
	U32	 InvSincBypass;
	U32	 InvCicBypass;
	U32	 SpectralInverse;
	U32	 CicInterpolateRate;
  	U32	 StartSource;
	U32	 StartInverse;
	U32  StartTrigger; 
	U32	 StopSource;
	U32	 StopInverse;
	float ThresholdComp1;
} ADM_PARAM;				// ADMQM9857 

ADM_PARAM   g_AdmParam =	// Read from ini-file
{
    0,			// ClockSource: 0-internal, 1-external
    160000000,	// ClockValue (Hz) 
    1,			// ChannelsMask: 1,3 
  	0,			// OperateMode
  	10000000,	// CarrierFreq (Hz)
  	1000000,	// ModulateFreq (Hz)
	2048,		// AmpModulateFreq
	0,			// OffsetSampleModFreq
  	180,		// OutputScaleFactor
	4,			// RefClockMultiply
	0,			// InvSincBypass
	0,			// SpectralInverse
	0,			// InvCicBypass
	0,			// CicInterpolateRate;
  	0,			// StartSource: source of start : 0-programm, 2-SDX(comparator 1)
	0,			// StartInverse: inverse signal start: 0-no, 1-yes    
	0,			// StartTrigger: start mode : 0- potential, 1-trigger
	0,			// StopSource: source of stop by trigger start mode
	0,			// StopInverse: inverse signal stop: 0-no, 1-yes
	0.1,		// ThresholdComp1 (v)
};
//---------------------------------------------------------------------------

//=**************************** ReadIniPrepare ******************************
//=***************************************************************************
typedef struct {char section[25]; int format;void *ptr; char title[25]; } TReadIniEntry;
static TReadIniEntry    iniEntry[] =
{
	{"Option", 0, (void*)&g_ExamParam.WorkMode, "WorkMode" },
	{"Option", 0, (void*)&g_ExamParam.SamplesPerChannel, "SamplesPerChannel" },
	{"Option", 0, (void*)&g_ExamParam.IsSystemMemory, "IsSystemMemory" },
	{"Option", 0, (void*)&g_ExamParam.MasterSlave, "MasterSlave" },
	{"Option", 3, (void*)&g_ExamParam.PldFileName, "PldFileName" },
	{"Option", 0, (void*)&g_ExamParam.IsAlwaysLoadPld, "IsAlwaysLoadPld" },
    {"device_qm98570", 0, (void*)&g_AdmParam.ClockSource,"ClockSource" },
    {"device_qm98570", 0, (void*)&g_AdmParam.ClockValue,"ClockValue" },
	{"device_qm98570", 0, (void*)&g_AdmParam.MaskChannels, "MaskChannels" },
	{"device_qm98570", 0, (void*)&g_AdmParam.OperateMode, "OperateMode" },
	{"device_qm98570", 0, (void*)&g_AdmParam.CarrierFreq, "CarrierFreq" },
	{"device_qm98570", 0, (void*)&g_AdmParam.ModulateFreq, "ModulateFreq" },
	{"device_qm98570", 0, (void*)&g_AdmParam.AmpModulateFreq, "AmpModulateFreq" },
	{"device_qm98570", 0, (void*)&g_AdmParam.OffsetSampleModFreq, "OffsetSampleModFreq" },
	{"device_qm98570", 0, (void*)&g_AdmParam.OutputScaleFactor, "OutputScaleFactor" },
	{"device_qm98570", 0, (void*)&g_AdmParam.RefClockMultiply, "RefClockMultiply" },
	{"device_qm98570", 0, (void*)&g_AdmParam.InvSincBypass, "InvSincBypass" },
	{"device_qm98570", 0, (void*)&g_AdmParam.SpectralInverse, "SpectralInverse" },
	{"device_qm98570", 0, (void*)&g_AdmParam.InvCicBypass, "InvCicBypass" },
	{"device_qm98570", 0, (void*)&g_AdmParam.CicInterpolateRate, "CicInterpolateRate" },
	{"device_qm98570", 0, (void*)&g_AdmParam.StartSource,"StartSource" },
    {"device_qm98570", 0, (void*)&g_AdmParam.StartInverse,"StartInverse" },
    {"device_qm98570", 0, (void*)&g_AdmParam.StartTrigger,"StartTrigger" },
    {"device_qm98570", 0, (void*)&g_AdmParam.StopSource,"StopSource" },
    {"device_qm98570", 0, (void*)&g_AdmParam.StopInverse,"StopInverse" },
    {"device_qm98570", 1, (void*)&g_AdmParam.ThresholdComp1,"ThresholdComp1" },

};
//---------------------------------------------------------------------------
BRD_Handle g_hCaptSrv[10];
S32 g_nCaptSrv = 0;
U32	g_NumberOfChannels;
double g_Delta= 0.4;
S32	g_MaxNumSamples=32768;	
U32	g_BufSize= 1024;
const U16 PLD_CFG_TAG	= 0x0500; // tag of PLD
double	WorkClockValue,SampleRate;
double	ModulateFreq;

void DisplayError(S32 status, TCHAR* cmd_str);
S32 FifoOutputCPU(BRD_Handle handle, PVOID pSig, ULONG bBufSize);
S32 FifoOutputDMA(BRD_Handle handle);
S32 FifoOutputCycleDMA(BRD_Handle handle);
double  CalcSignalParam(double *freq,double samplrate,int *nsamples,int maxNumSamples,int outmode);
S32 CalcSignal(S32 *samples, S32 nsamples,double delta);

S32	 CaptureSrv(BRD_Handle handle,TCHAR* serviceName );
S32	 SetParamSrv(void);
S32  WorkSrv(void);
bool    ReadIniFile( TCHAR *pFileName );
static void GetInifileString(LPCTSTR FileName, LPCTSTR SectionName, LPCTSTR ParamName, LPSTR defValue, LPSTR strValue, int strSize);

//=************************* main *************************
//=********************************************************
void main( int argc, char *argv[] )
{
	S32		status;

	if(!ReadIniFile(g_ExamParam.IniFileName ))
	{
		printf("Can't open file: %s !\n",g_ExamParam.IniFileName);
		printf("Press any key for leaving program...\n");
		_getch();
		_exit(0);
	}
	BRD_displayMode(BRDdm_VISIBLE | BRDdm_CONSOLE); //     :     
	
	S32	DevNum;
	status = BRD_init("brd.ini", &DevNum); //  

	//   LID (   )
	BRD_LidList lidList;
	lidList.item = 10;
	lidList.pLID = new U32[10];
	status = BRD_lidList(lidList.pLID, lidList.item, &lidList.itemReal);

	BRD_Info	info;
	info.size = sizeof(info);
	BRD_Handle handle[10];

	for(ULONG iDev = 0; iDev < lidList.itemReal; iDev++)
	{
		BRD_getInfo(lidList.pLID[iDev], &info); //    
		printf("Board %d:  %s pid = %d\n",iDev,info.name,info.pid);
		printf("   DevID = 0x%x, RevID = 0x%x, Bus = %d, Dev= %d, Slot= %d.\n", 
			    info.boardType >> 16, info.boardType & 0xff, info.bus, info.dev, info.slot);
		handle[iDev] = BRD_open(lidList.pLID[iDev], BRDopen_SHARED, NULL); //   
		if(handle[iDev] <=0)printf("   Open Error!\n");
		if(handle[iDev] > 0)
		{
			BRD_PuList PuList[5];
			U32 ItemReal;
			status = BRD_puList(handle[iDev], PuList, 5, &ItemReal); //    
			if(ItemReal > 5)
			{
				ItemReal=5; 
				printf("   Number of programable unit >5 !\n");
			}
			for(U32 j = 0; j < ItemReal; j++)
			{
				printf("   Prog unit %d: %s, Id = %d, Code = %x, Attr = %x.\n",
									j, PuList[j].puDescription, PuList[j].puId, PuList[j].puCode, PuList[j].puAttr);
				
				if(PuList[j].puCode == PLD_CFG_TAG)
				{ //   
						U32	PldState;
						status = BRD_puState(handle[iDev], PuList[j].puId, &PldState);
						printf("   PLD State = %d\n", PldState);
						if(PldState==0 || g_ExamParam.IsAlwaysLoadPld==1)
						{ //  
					 		printf("   Loading PLD -> %s ...",g_ExamParam.PldFileName);
							status = BRD_puLoad(handle[iDev], PuList[j].puId, g_ExamParam.PldFileName, &PldState);
							if(BRD_errcmp(status, BRDerr_OK))
							{	
								printf(" OK!\n");
								PldState=1;
							}
							else 
							{	
								printf("  Error! \n");
								PldState=0;
							}
					    }
						if(PldState)CaptureSrv(handle[iDev],g_ExamParam.ServiceName);		
		         }
             }
         }
	}
	if(g_nCaptSrv>0)
	{
		SetParamSrv();
		WorkSrv();
	}else
	{
		printf("\n   No Service!\n");
	}
	for(int i = 0; i < g_nCaptSrv; i++)
		status = BRD_release(g_hCaptSrv[i], 0);
	for(ULONG iDev = 0; iDev < lidList.itemReal; iDev++)
		status = BRD_close(handle[iDev]); //   
	printf("\n BRD_close: OK\n");
	status = BRD_cleanup();
	printf(" BRD_cleanup: OK\n");
	printf("Press any key for leaving program...\n");
	_getch();
}
//-******************************** End main **************************************
//=*****************************   *********************************
//=*********************************************************************************
S32	CaptureSrv(BRD_Handle handle,TCHAR* serviceName )
{
	S32		status;
	U32 mode = BRDcapt_EXCLUSIVE;
	U32	ItemReal;
	BRD_ServList srvList[10];
	status = BRD_serviceList(handle, 0, srvList, 10, &ItemReal);
	for(U32 j = 0; j < ItemReal; j++)
	{
		printf("   Srv %d:  %s, Attr = %X.\n",j, srvList[j].name, srvList[j].attr);
	}
    for(U32 iSrv = 0;iSrv < ItemReal; iSrv++)
    {			
		if(!strcmp(srvList[iSrv].name,g_ExamParam.ServiceName))
		{
		   printf("   Capture %s mode: EXCLUSIVE...",g_ExamParam.ServiceName); 
		   BRD_Handle hSrv = BRD_capture(handle, 0, &mode,srvList[iSrv].name, 10000);
			if(hSrv > 0)
			{
				g_hCaptSrv[g_nCaptSrv++]=hSrv;
				printf("OK!\n");

			}else
			{
				printf("Error!\n");
			}
		}
    }	
	return status;
}
//=**************************************************************************
//					    
//=************************************************************************************
S32	SetParamSrv(void)
{
	S32	status;
	S32	iSrv=0; //!!
	U32 master=BRDims_SINGLE;
	U32		rcm; 
	U32		nftword ;
	double	dd4G=(double)1024.0*(double)1024.0*(double)4096.0;
	
	status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_QM_SETMASTER, &master);
	if(!BRD_errcmp(status, BRDerr_OK))DisplayError(status, "BRDctrl_QM_SETMASTER");

	//---------------------     ---------------------
	status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_QM_SETCLKSOURCE, &g_AdmParam.ClockSource);
    if(!BRD_errcmp(status, BRDerr_OK))DisplayError(status, "BRDctrl_QM_SETCLKSOURCE");	
	if(g_AdmParam.ClockSource==0)printf("ClockSource = INTERNAL\n");
	else  printf("ClockSource = EXTERNAL\n");
	printf("ClockValue = %f MHz\n",(double)g_AdmParam.ClockValue/1000000);

	status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_QM_SETCHANMASK, &g_AdmParam.MaskChannels);
	if(!BRD_errcmp(status, BRDerr_OK))DisplayError(status, "BRDctrl_QM_SETCHANMASK");
	g_NumberOfChannels=1;
	if(g_AdmParam.MaskChannels==3)g_NumberOfChannels=2;

//---------------- Set Main Params QM9857---------------------
	BRD_QmSetMainParam  mainParam;
 
	mainParam.progMask = 3;
	mainParam.pllLock = 1;
	mainParam.clockMult = g_AdmParam.RefClockMultiply;
	mainParam.cicClear = 0;
	mainParam.invSincBypass = g_AdmParam.InvSincBypass;
	mainParam.fullSleep = 0;
	mainParam.autoPowerDown = 0;
	mainParam.operatingMode = g_AdmParam.OperateMode;

	rcm = mainParam.clockMult;
	if(rcm<4)rcm = 1;
	else if(rcm>20) rcm = 20;
	nftword = (U32)( ( ( (double)dd4G/(double)rcm ) *(double)(g_AdmParam.CarrierFreq) )/(double)(g_AdmParam.ClockValue) );
 //----------------- Set Profile ----------------------------
	BRD_QmSetProfile		qmSetProfile;

	qmSetProfile.progMask = 3;
	qmSetProfile.profNum = 0;
	qmSetProfile.freqNco = nftword;
	qmSetProfile.cicRate = g_AdmParam.CicInterpolateRate;
	qmSetProfile.spectrInv = g_AdmParam.SpectralInverse;
	qmSetProfile.invCicBypass = g_AdmParam.InvCicBypass;
	qmSetProfile.outputScale = g_AdmParam.OutputScaleFactor;

	WorkClockValue=(double)g_AdmParam.ClockValue*rcm;
	SampleRate=WorkClockValue/(4*qmSetProfile.cicRate);

	ModulateFreq= (double)g_AdmParam.ModulateFreq;
	g_Delta=CalcSignalParam(&ModulateFreq,
							SampleRate,
							(int*)&g_ExamParam.SamplesPerChannel,
							g_MaxNumSamples,
							g_ExamParam.WorkMode);

	g_BufSize=g_ExamParam.SamplesPerChannel*4;
	g_BufSize *=g_NumberOfChannels;
	if(g_AdmParam.OperateMode ==2)g_BufSize /=2;	//  
				
	status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_QM_QMRESET, NULL);
	status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_QM_SETMAINPARAM, &mainParam);
	status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_QM_SETPROFILE, &qmSetProfile);

	//-----------------------    ----------------------------------
	BRD_StartMode  startMode;
	startMode.startSrc= g_AdmParam.StartSource;
	startMode.startInv= g_AdmParam.StartInverse;
	startMode.trigOn= g_AdmParam.StartTrigger;
	startMode.trigStopSrc= g_AdmParam.StopSource;
	startMode.stopInv= g_AdmParam.StopInverse;
	startMode.reStartMode=0;
	status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_QM_SETSTARTMODE, &startMode);
	if(!BRD_errcmp(status, BRDerr_OK)) DisplayError(status, "BRDctrl_QM_SETSTARTMODE");

	BRD_CmpSC cmp_sc;
	cmp_sc.src = BRDcmps_CHAN0CLK;
	cmp_sc.thr[0] = g_AdmParam.ThresholdComp1;
	cmp_sc.thr[1] = g_AdmParam.ThresholdComp1;
	status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_CMPSC_SET, &cmp_sc);
	if(!BRD_errcmp(status, BRDerr_OK)) DisplayError(status, "BRDctrl_CMPSC_SET");


	return 1;
}
//=*************************************************************************************
//					  
//=*************************************************************************************
S32	WorkSrv(void)
{
	S32	status,nblock=0;
	S32 iSrv=0; // !!

	printf("SamplesPerChannel= %d\n",g_ExamParam.SamplesPerChannel);
	printf("BufSize= %d byte \n",g_BufSize);


	if(g_AdmParam.OperateMode== 1) //   (DDS)
	{
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_QM_UPDATEFREQ, &g_AdmParam.MaskChannels);
   		printf("\nOperateMode=1 - Generator (DDS)\n");
		printf("Presss any key for exit\n");
		_getch();
		return 1; 
	}
//--------------------------------------------------------------------------------------
	if(g_ExamParam.WorkMode==0) //    DMA (  )
	{
		printf("SampleRate= %f MHz\n",SampleRate/1000000);
		printf("\nOne time output DMA (program cycle)\n");
		BRDctrl_StreamCBufAlloc buf_dscr;
		buf_dscr.dir = BRDstrm_DIR_OUT;
		buf_dscr.isCont = g_ExamParam.IsSystemMemory; 
		buf_dscr.blkNum = 1;
		buf_dscr.blkSize = g_BufSize;
		buf_dscr.ppBlk = new PVOID[buf_dscr.blkNum];
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_CBUF_ALLOC, &buf_dscr);
		CalcSignal((S32*)buf_dscr.ppBlk[0], g_ExamParam.SamplesPerChannel,g_Delta);
		printf("Presss any key  for stop\n");
		printf("\nBLOCK %d",nblock);
		while(!_kbhit())
		{
			if(FifoOutputDMA(g_hCaptSrv[iSrv])==1)goto end0;
			nblock++;
			printf("\rBLOCK %d",nblock);

		}
		_getch();
end0:		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_CBUF_FREE, &buf_dscr);
		delete[] buf_dscr.ppBlk;
	}
//--------------------------------------------------------------------------------------
	if(g_ExamParam.WorkMode==1) //    CPU (  )
	{
		printf("SampleRate= %f MHz\n",SampleRate/1000000);
		printf("\nOne time output CPU (program cycle)\n");
		int *pSig = new int[g_BufSize];
		CalcSignal(pSig, g_ExamParam.SamplesPerChannel,g_Delta);

		printf("Presss any key  for stop\n");
		printf("\nBLOCK %d",nblock);
		while(!_kbhit())
		{
			FifoOutputCPU(g_hCaptSrv[iSrv], pSig, g_BufSize );
			nblock++;
			printf("\rBLOCK %d",nblock);
		}
		_getch();
		delete pSig;
	}
//--------------------------------------------------------------------------------------
	if(g_ExamParam.WorkMode==2) //     DMA 
	{
		printf("SampleRate= %f MHz\n",SampleRate/1000000);
		printf("\nContinuous output DMA\n");
		BRDctrl_StreamCBufAlloc buf_dscr;
		buf_dscr.dir = BRDstrm_DIR_OUT;
		buf_dscr.isCont = g_ExamParam.IsSystemMemory;
		buf_dscr.blkNum = 1;
		buf_dscr.blkSize = g_BufSize;
		buf_dscr.ppBlk = new PVOID[buf_dscr.blkNum];

		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_CBUF_ALLOC, &buf_dscr);

		CalcSignal((S32*)buf_dscr.ppBlk[0], g_ExamParam.SamplesPerChannel,g_Delta);
		printf("Presss any key for exit\n");
		FifoOutputCycleDMA(g_hCaptSrv[iSrv]);
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_CBUF_FREE, &buf_dscr);
		delete[] buf_dscr.ppBlk;
	}


	return 1;
}
//---------------------------------------------------------------------------------------
//=**************************************************************************************

//      ini-:
//    FileName -  ini- ( ,  )
//    SectionName -  
//    ParamName -   ()
//    defValue -   - (    )
//    strValue -  
//    strSize -   
static void GetInifileString(LPCTSTR FileName, LPCTSTR SectionName, LPCTSTR ParamName, LPSTR defValue, LPSTR strValue, int strSize)
{
	GetPrivateProfileString(SectionName, ParamName, defValue, strValue, strSize, FileName);
	TCHAR* pChar = _tcschr(strValue, ';');
	if(pChar) *pChar = 0; //    
	int str_size = lstrlen(strValue);
	for(int i = str_size - 1; i > 1; i--)
		if(strValue[i] != ' ' && strValue[i] != '\t')
		{
			strValue[i+1] = 0;
			break;
		}
}
//=*********************************************************************

//=*********************************************************************
//=**************************   ****************
//=*********************************************************************
bool    ReadIniFile( TCHAR *pFileName )
{
	TCHAR Buffer[128];
	TCHAR *endptr;
	TCHAR iniFilePath[MAX_PATH];
	FILE    *stream;

	GetCurrentDirectory(sizeof(iniFilePath)/sizeof(TCHAR), iniFilePath);

	_tcscat_s(iniFilePath, pFileName);
	stream = fopen(iniFilePath, "rt" );
    if( stream == NULL)return false;
	else     fclose(stream);

    for(int i=0; i<sizeof(iniEntry)/sizeof(iniEntry[0]); i++ )
	{
		GetPrivateProfileString(iniEntry[i].section, iniEntry[i].title, "0", Buffer, sizeof(Buffer), iniFilePath);
		switch(iniEntry[i].format){
			case 0:	
				{
					int     base = 10;
					char    *s = Buffer;
					while (isspace(*s)) s++;
                    if( (s[0]=='0') && ((s[1]=='x') || (s[1]=='X')) )
                    base = 16;
                    *(int*)iniEntry[i].ptr = strtoul( Buffer, &endptr, base );
				}
				break;
			case 1:	*(float*)iniEntry[i].ptr=(float)atof(Buffer);
				break;
			case 2:	*(double*)iniEntry[i].ptr=atof(Buffer);
				break;
			case 3:	 
				GetInifileString(iniFilePath, iniEntry[i].section, iniEntry[i].title, "0", Buffer, sizeof(Buffer));
				lstrcpy((TCHAR*)iniEntry[i].ptr,Buffer);
				break;

		}
	}
	return true;
}
//=**********************************************************************
void DisplayError(S32 status, TCHAR* cmd_str)
{
	S32	real_status = BRD_errext(status);
	TCHAR msg[255];
	switch(real_status)
	{
	case BRDerr_OK:
		sprintf_s(msg, "%s: BRDerr_OK\n", cmd_str);
		break;
	case BRDerr_BAD_MODE:
		sprintf_s(msg, "%s: BRDerr_BAD_MODE\n", cmd_str);
		break;
	case BRDerr_INSUFFICIENT_SERVICES:
		sprintf_s(msg, "%s: BRDerr_INSUFFICIENT_SERVICES\n", cmd_str);
		break;
	default:
		sprintf_s(msg, "%s: Unknown error\n", cmd_str);
		break;
	}
	printf(msg);
}

//-------------------------------------------------------------------------
//         FIFO
//-------------------------------------------------------------------------
S32 FifoOutputCPU(BRD_Handle handle, PVOID pSig, ULONG bBufSize)
{
	
	S32		status;
	ULONG Status = 0;

	status = BRD_ctrl(handle, 0, BRDctrl_QM_STOP, NULL);	  //  
	status = BRD_ctrl(handle, 0, BRDctrl_QM_FIFORESET, NULL); //  FIFO 
	BRD_DataBuf data_buf;
	data_buf.pData = pSig;
	data_buf.size = bBufSize;
	status = BRD_ctrl(handle, 0, BRDctrl_QM_PUTDATA, &data_buf);
	status = BRD_ctrl(handle, 0, BRDctrl_QM_START, NULL); //   
	U32		statusFIFO=0x4;
    while((statusFIFO & (1<<2))==(1<<2))//      FIFO  QM9857 
    {
	       status = BRD_ctrl(handle, 0, BRDctrl_QM_FIFOSTATUS, &statusFIFO); 
    }

	status = BRD_ctrl(handle, 0, BRDctrl_QM_STOP, NULL); //   
	return status;

}

#include	<math.h>
#define TWO_PI (8.0*atan(1.0))

//       -   
//----------------------------------------------------------------------
S32 FifoOutputDMA(BRD_Handle handle)
{

	S32		status;
	ULONG Status = 0;
	ULONG flag = BRDstrm_DRQ_HALF; 

	status = BRD_ctrl(handle, 0, BRDctrl_STREAM_SETDRQ, &flag);
	status = BRD_ctrl(handle, 0, BRDctrl_QM_STOP, NULL);	//  
	status = BRD_ctrl(handle, 0, BRDctrl_QM_FIFORESET, NULL); //  FIFO 


	BRDctrl_StreamCBufStart start_pars;
	start_pars.isCycle = 0; //   
	status = BRD_ctrl(handle, 0, BRDctrl_STREAM_CBUF_START, &start_pars); //  
	status = BRD_ctrl(handle, 0, BRDctrl_QM_START, NULL); //   
	int fl_break = 0;

	ULONG msTimeout = 20000; //       20 .
	status = BRD_ctrl(handle, 0, BRDctrl_STREAM_CBUF_WAITBLOCK, &msTimeout);
	if(BRD_errcmp(status, BRDerr_WAIT_TIMEOUT))
	{	//   -
		printf("\nTIME-OUT! \n");
		fl_break = 1;
		status = BRD_ctrl(handle, 0, BRDctrl_QM_STOP, NULL); //   
		return 1;
	}
	U32		statusFIFO=0x4;
 
	while((statusFIFO & (1<<2))==(1<<2))//      FIFO  QM9857 
    {
	       status = BRD_ctrl(handle, 0, BRDctrl_QM_FIFOSTATUS, &statusFIFO); 
    }

	status = BRD_ctrl(handle, 0, BRDctrl_QM_STOP, NULL); //   

	return 0;

}

//       -   
//----------------------------------------------------------------------
S32 FifoOutputCycleDMA(BRD_Handle handle)
{

	S32		status;
	ULONG Status = 0;
	ULONG flag = BRDstrm_DRQ_HALF; 

	status = BRD_ctrl(handle, 0, BRDctrl_STREAM_SETDRQ, &flag);
	status = BRD_ctrl(handle, 0, BRDctrl_QM_STOP, NULL); //  
	status = BRD_ctrl(handle, 0, BRDctrl_QM_FIFORESET, NULL); //  FIFO 

	status = BRD_ctrl(handle, 0, BRDctrl_QM_FIFOSTATUS, &Status);

	BRDctrl_StreamCBufStart start_pars;
	start_pars.isCycle = 1; //  
	status = BRD_ctrl(handle, 0, BRDctrl_STREAM_CBUF_START, &start_pars); //  
	status = BRD_ctrl(handle, 0, BRDctrl_QM_START, NULL); //   
	int fl_break = 0;
	ULONG msTimeout = 20000; //       20 .
	int	nblock=0;
	while(!_kbhit())
	{
		status = BRD_ctrl(handle, 0, BRDctrl_STREAM_CBUF_WAITBLOCK, &msTimeout);
		if(BRD_errcmp(status, BRDerr_WAIT_TIMEOUT))
		{	//   -
			printf("\nTIME-OUT! \n");
			status = BRD_ctrl(handle, 0, BRDctrl_QM_STOP, NULL); //   
			return 1;
		}
		nblock++;
		printf("\rBLOCK %d",nblock);
	}
	_getch();
	status = BRD_ctrl(handle, 0, BRDctrl_QM_STOP, NULL); //   

	return 0;

}
//=******************** Calculate of signal param ****************************
//---------------------------------------------------------------------------
double  CalcSignalParam(double *freq,double samplrate,int *nsamples,int maxNumSamples,int outmode)
{
    double fr=*freq;
    int    ns=*nsamples;
    double sr=samplrate;
    double dfr;
    double dt;
    double mindfr=100000000;
    int    minn;
    int    mink;
    int k,n;
	if(outmode<2)return PI2*(fr/sr);
//	return PI2*(fr/sr);


 //   for(n=1024;n<maxNumSamples;n +=64)
    for(n=1024;n<maxNumSamples;n +=1024)
    {
        for(k=1;k<=n/2;k++)
        {
          dfr=fabs(fr-k*sr/n);
          if(dfr<mindfr)
          {
            mindfr=dfr;
            minn=n;
            mink=k;
          }
        }
    }
//	minn *=2;
    fr=mink*sr/minn;
    dt=PI2*mink/minn;
    *freq=fr;
    // !!!!!!!!!!!!!!!!!
    k=maxNumSamples/minn;
    k=2;
    minn=k*minn; 
    // !!!!!!!!!!!!!!!!!
    *nsamples=minn;
    return dt;

}
//-----------------------------------------------------------------------
//=******************** Calculate samples of  signal  *******************
//-----------------------------------------------------------------------

S32 CalcSignal(S32 *samples, S32 nsamples,double delta)
{
	S32 Is,Qs;
	S32	sample;
	if(g_AdmParam.OperateMode==0) //------------- 
	{
		if(g_NumberOfChannels==1)
		{
			for(int i=0;i<nsamples;i++)
			{
				Is=(S32)(g_AdmParam.AmpModulateFreq*cos(i*delta)) + g_AdmParam.OffsetSampleModFreq;
//				Qs=(S32)((-1)*g_AdmParam.AmpModulateFreq*sin(i*delta)) + g_AdmParam.OffsetSampleModFreq;
				Qs=(S32)(g_AdmParam.AmpModulateFreq*sin(i*delta)) + g_AdmParam.OffsetSampleModFreq;
				samples[i]=(0xffff & Is<<2) | (0xfffc0000 & Qs<<18);

			}
			if(g_ExamParam.WorkMode!=2)
			{
				samples[nsamples-2 ]=0;  
				samples[nsamples-1]=0;
			}
		}
		if(g_NumberOfChannels==2)
		{
			for(int i=0;i<nsamples;i++)
			{
				Is=(S32)(g_AdmParam.AmpModulateFreq*cos(i*delta)) + g_AdmParam.OffsetSampleModFreq;
//				Qs=(S32)((-1)*g_AdmParam.AmpModulateFreq*sin(i*delta)) + g_AdmParam.OffsetSampleModFreq;
				Qs=(S32)(g_AdmParam.AmpModulateFreq*sin(i*delta)) + g_AdmParam.OffsetSampleModFreq;
				samples[2*i]=(0xffff & Is<<2) | (0xfffc0000 & Is<<18);
				samples[2*i+1]=(0xffff & Qs<<2) | (0xfffc0000 & Qs<<18);
	        }
			if(g_ExamParam.WorkMode!=2)
			{
				samples[2*nsamples-2]=0;  
				samples[2*nsamples-1]=0;
			}

		}

	}
	if(g_AdmParam.OperateMode==2) //----------------  
	{
		if(g_NumberOfChannels==1)
		{
			for(int i=0;i<nsamples/2;i++)
			{
				Is=(S32)(g_AdmParam.AmpModulateFreq*sin((2*i)*delta)) + g_AdmParam.OffsetSampleModFreq;
				Qs=(S32)(g_AdmParam.AmpModulateFreq*sin((2*i+1)*delta)) + g_AdmParam.OffsetSampleModFreq;
				samples[i]=(0xffff & Is<<2) | (0xfffc0000 & Qs<<18);
	        }
		if(g_ExamParam.WorkMode!=2)
		{
			samples[nsamples/2-2 ]=0;  
			samples[nsamples/2-1]=0;
		}
		}
		if(g_NumberOfChannels==2)
		{
			for(int i=0;i<nsamples/2;i++)
			{
				Is=(S32)(g_AdmParam.AmpModulateFreq*sin((2*i)*delta)) + g_AdmParam.OffsetSampleModFreq;
				Qs=(S32)(g_AdmParam.AmpModulateFreq*sin((2*i+1)*delta)) + g_AdmParam.OffsetSampleModFreq;
				samples[2*i]=(0xffff & Is<<2) | (0xfffc0000 & Is<<18);
				samples[2*i+1]=(0xffff & Qs<<2) | (0xfffc0000 & Qs<<18);
	        }
		if(g_ExamParam.WorkMode!=2)
		{
			samples[nsamples-2 ]=0;  
			samples[nsamples-1]=0;
		}
		}


	}

return 1;
}
//----------------------------------------------------------------------

//
// End of file
//
